
   MEMBER

   MAP
   .

   Include('jhSliderCL.inc'),ONCE


!mem:Icon:Slider:On:Enabled    EQUATE('~X:\Clarion\jhIcons\16\Slider-On.png')
!mem:Icon:Slider:On:Disabled   EQUATE('~X:\Clarion\jhIcons\16\Slider-On-Disabled.png')
!mem:Icon:Slider:Off:Enabled   EQUATE('~X:\Clarion\jhIcons\16\Slider-Off.png')
!mem:Icon:Slider:Off:Disabled  EQUATE('~X:\Clarion\jhIcons\16\Slider-Off-Disabled.png')

mem:Icon:Slider:On:Enabled     EQUATE('~Slider-On.png')
mem:Icon:Slider:On:Disabled    EQUATE('~Slider-On-Disabled.png')
mem:Icon:Slider:Off:Enabled    EQUATE('~Slider-Off.png')
mem:Icon:Slider:Off:Disabled   EQUATE('~Slider-Off-Disabled.png')

jhEntryQ_Type                 Queue,Type
dwFEQ                            LONG
dwImageFEQ                       LONG
dwRegionFEQ                      LONG

theField                         ANY            ! Use this to reference the actual variable, typically a BYTE but can be a LONG
                              .  

   



!=======================================================================================================================
!--      
jhSliderCL_type.Construct  PROCEDURE
   Code
      SELF.EntryQ &= NEW(jhEntryQ_Type)
      
      
!=======================================================================================================================
!--      
jhSliderCL_type.Destruct   PROCEDURE
i                             LONG
   Code            
      !-- Release the EntryQ ..
      !--
      if RECORDS(SELF.EntryQ)
         Loop i = RECORDS(SELF.EntryQ) TO 1 BY -1
            GET(SELF.EntryQ,i)
            if ~ERRORCODE()
               SELF.EntryQ.theField &= NULL
               DELETE(SELF.EntryQ)
            .
         .
      .

      DISPOSE(SELF.EntryQ)
                                       
      
!=======================================================================================================================
!--      
jhSliderCL_type.SetValue PROCEDURE(LONG inFEQ,BYTE inValue,BYTE inEnabled=1)
   Code  
      SELF.EntryQ.dwFEQ = inFEQ
      GET(SELF.EntryQ,SELF.EntryQ.dwFEQ)
      if ~ERRORCODE()
         if inValue = TRUE
            SELF.EntryQ.dwImageFEQ{PROP:Text} = ''
            SELF.EntryQ.dwImageFEQ{PROP:Text} = CHOOSE(inEnabled=TRUE,mem:Icon:Slider:On:Enabled,mem:Icon:Slider:On:Disabled)
            SELF.EntryQ.theField = TRUE
         ELSE
            SELF.EntryQ.dwImageFEQ{PROP:Text} = ''
            SELF.EntryQ.dwImageFEQ{PROP:Text} = CHOOSE(inEnabled=TRUE,mem:Icon:Slider:Off:Enabled,mem:Icon:Slider:Off:Disabled)
            SELF.EntryQ.theField = TRUE
         .
         
         PUT(SELF.EntryQ)
      .


!=======================================================================================================================
!--      
jhSliderCL_type.GetValue PROCEDURE(LONG inFEQ)
   Code  
      SELF.EntryQ.dwFEQ = inFEQ
      GET(SELF.EntryQ,SELF.EntryQ.dwFEQ)
      if ~ERRORCODE()
         Return(SELF.EntryQ.theField)
      .
      
      Return(0)

      
!=======================================================================================================================
!-- Create a new "Slider" ..
!--   1. Hide the underlying check box control
!--   2. Create Region and position it over the original check box
!--   3. Create an Image control and display the graphic
!--      
jhSliderCL_type.AddEntry   PROCEDURE(LONG inFEQ,*? ioVariable,LONG inParentFEQ)
   Code          
      !-- Hide inFEQ ..
      !-- 
      HIDE(inFEQ)
        
      CLEAR(SELF.EntryQ)
      SELF.EntryQ.dwFEQ = inFEQ            
      SELF.EntryQ.theField &= ioVariable
      
      !-- Create the Region FEQ ..
      !--
      SELF.EntryQ.dwRegionFEQ = Create(0,CREATE:REGION,inParentFEQ)
      SELF.EntryQ.dwRegionFEQ{PROP:Xpos} = inFEQ{PROP:Xpos}
      SELF.EntryQ.dwRegionFEQ{PROP:Ypos} = inFEQ{PROP:Ypos}
      SELF.EntryQ.dwRegionFEQ{PROP:Width} = inFEQ{PROP:Width}
      SELF.EntryQ.dwRegionFEQ{PROP:Height} = inFEQ{PROP:Height}
      SELF.EntryQ.dwRegionFEQ{PROP:Imm} = TRUE
      UNHIDE(SELF.EntryQ.dwRegionFEQ)         
      
      SELF.EntryQ.dwImageFEQ = CREATE(0,CREATE:Image,inParentFEQ)
      SELF.EntryQ.dwImageFEQ{PROP:Xpos} = inFEQ{PROP:Xpos}
      SELF.EntryQ.dwImageFEQ{PROP:Ypos} = inFEQ{PROP:Ypos}
      SELF.EntryQ.dwImageFEQ{PROP:Width} = inFEQ{PROP:Width}
      SELF.EntryQ.dwImageFEQ{PROP:Height} = inFEQ{PROP:Height}
      SELF.EntryQ.dwImageFEQ{PROP:Centered} = TRUE
      
      if SELF.EntryQ.theField = TRUE
         SELF.EntryQ.dwImageFEQ{PROP:Text} = mem:Icon:Slider:On:Enabled
      ELSE
         SELF.EntryQ.dwImageFEQ{PROP:Text} = mem:Icon:Slider:Off:Enabled
      .
         
      UNHIDE(SELF.EntryQ.dwImageFEQ)         
      
      Add(SELF.EntryQ)
      
      
              
!=======================================================================================================================
!-- Enable/Disable the control, ie: change the slider graphic and change the Region{PROP:IMM}
!--      
jhSliderCL_Type.Enable     PROCEDURE(LONG inFEQ)                       
   Code
      SELF.EntryQ.dwFEQ = inFEQ
      GET(SELF.EntryQ,SELF.EntryQ.dwFEQ)
      if ~ERRORCODE()                  
         
         !-- Turn on the Region's IMM Attribute
         SELF.EntryQ.dwRegionFEQ{PROP:IMM} = TRUE
         
         !-- Change the slider image ..
         if SELF.EntryQ.theField = TRUE
            !-- Only Change the image if we need to, this will prevent screen flicker
            if SELF.EntryQ.dwImageFEQ{PROP:Text} ~= mem:Icon:Slider:On:Enabled
               SELF.EntryQ.dwImageFEQ{PROP:Text} = ''
               SELF.EntryQ.dwImageFEQ{PROP:Text} = mem:Icon:Slider:On:Enabled
            .
         ELSE
            !-- Only Change the image if we need to, this will prevent screen flicker
            if SELF.EntryQ.dwImageFEQ{PROP:Text} ~= mem:Icon:Slider:Off:Enabled
               SELF.EntryQ.dwImageFEQ{PROP:Text} = ''
               SELF.EntryQ.dwImageFEQ{PROP:Text} = mem:Icon:Slider:Off:Enabled
            .
         .
         
         PUT(SELF.EntryQ)
      .
      

!=======================================================================================================================
!-- Disable the control, ie: change the slider graphic and change the Region{PROP:IMM}
!--      
jhSliderCL_Type.Disable PROCEDURE(LONG inFEQ)                       
   Code          
      SELF.EntryQ.dwFEQ = inFEQ
      GET(SELF.EntryQ,SELF.EntryQ.dwFEQ)
      if ~ERRORCODE()
         
         !-- Turn off the Region's IMM attribute
         SELF.EntryQ.dwRegionFEQ{PROP:IMM} = FALSE
         
         !-- Change the slider image
         if SELF.EntryQ.theField = TRUE
            !-- Only Change the image if we need to, this will prevent screen flicker
            if SELF.EntryQ.dwImageFEQ{PROP:Text} ~= mem:Icon:Slider:On:Disabled
               SELF.EntryQ.dwImageFEQ{PROP:Text} = ''
               SELF.EntryQ.dwImageFEQ{PROP:Text} = mem:Icon:Slider:On:Disabled
            .
         ELSE
            !-- Only Change the image if we need to, this will prevent screen flicker
            if SELF.EntryQ.dwImageFEQ{PROP:Text} ~= mem:Icon:Slider:Off:Disabled
               SELF.EntryQ.dwImageFEQ{PROP:Text} = ''                
               SELF.EntryQ.dwImageFEQ{PROP:Text} = mem:Icon:Slider:Off:Disabled
            .
         .
         
         PUT(SELF.EntryQ)
      .
      
      
      
      
      
      
!=======================================================================================================================
!--      
jhSliderCL_Type.TakeEvent  PROCEDURE
   Code
      CASE Event()
      of EVENT:MouseUp
         !-- Did the User Click Over a slider RegionFEQ  ?
         !--
         SELF.EntryQ.dwRegionFEQ = FIELD()
         GET(SELF.EntryQ,SELF.EntryQ.dwRegionFEQ)
         if ~ERRORCODE()
            if SELF.EntryQ.theField = TRUE
               SELF.EntryQ.theField = FALSE
               SELF.EntryQ.dwImageFEQ{PROP:Text} = ''
               SELF.EntryQ.dwImageFEQ{PROP:Text} = mem:Icon:Slider:Off:Enabled
            ELSE
               SELF.EntryQ.theField = TRUE
               SELF.EntryQ.dwImageFEQ{PROP:Text} = ''
               SELF.EntryQ.dwImageFEQ{PROP:Text} = mem:Icon:Slider:On:Enabled
            .       
                   
            PUT(SELF.EntryQ)
         .
         
         !-- POST an Event:Accepted to the underlying FEQ so that it can be processed as normal
         !--
         POST(EVENT:Accepted,SELF.EntryQ.dwFEQ)
      .
      
         